VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   5055
   ClientLeft      =   1140
   ClientTop       =   1515
   ClientWidth     =   1815
   LinkTopic       =   "Form1"
   PaletteMode     =   1  'UseZOrder
   ScaleHeight     =   5055
   ScaleWidth      =   1815
   Begin VB.PictureBox TimePic 
      AutoRedraw      =   -1  'True
      Height          =   4335
      Left            =   120
      ScaleHeight     =   285
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   101
      TabIndex        =   0
      Top             =   120
      Width           =   1575
   End
   Begin VB.Label TimeLabel 
      Height          =   255
      Left            =   120
      TabIndex        =   1
      Top             =   4560
      Width           =   1575
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private num_hours As Integer
Private Drawing As Boolean
Private StartY As Integer
Private CurY As Integer
Private HourNames As New Collection
' Shade part of the picture.
Private Sub DrawBox(ByVal i1 As Integer, ByVal i2 As Integer)
Dim tmp As Integer
Dim y1 As Single
Dim y2 As Single

    If i1 > i2 Then
        tmp = i1
        i1 = i2
        i2 = tmp
    End If
    
    y1 = TimePic.ScaleHeight * (i1 - 1) / num_hours
    y2 = TimePic.ScaleHeight * i2 / num_hours
    
    TimePic.Cls
    TimePic.Line (0, y1)-(ScaleWidth, y2), vbRed, BF
    DrawHours
End Sub

' Draw hours on the PictureBox.
Private Sub DrawHours()
Dim i As Integer

    ' Draw times and lines on the PictureBox.
    For i = 2 To num_hours
        TimeLine TimePic, i - 1, HourNames(i)
    Next i
End Sub

' Draw a time line on the PictureBox.
Private Sub TimeLine(pic As PictureBox, i As Integer, txt As String)
Dim gap As Single
Dim Y As Single
Dim x1 As Single
Dim x2 As Single
Dim wid As Single

    gap = pic.ScaleX(4, vbPixels, pic.ScaleMode)
    Y = pic.ScaleHeight / num_hours * i
    wid = pic.TextWidth(txt)
    x1 = (pic.ScaleWidth - wid) / 2
    x2 = x1 + wid
    pic.CurrentX = x1
    pic.CurrentY = Y - ScaleY(pic.Font.Size, vbPoints, pic.ScaleMode) / 2
    pic.Print txt

    pic.Line (0, Y)-(x1 - gap, Y)
    pic.Line (x2 + gap, Y)-(pic.ScaleWidth, Y)
End Sub

' Return the hour number for this position.
Private Function YtoHour(Y As Single) As Integer
    YtoHour = Int((Y / TimePic.ScaleHeight) * num_hours) + 1
End Function

Private Sub Form_Load()
    HourNames.Add "7 am"
    HourNames.Add "8 am"
    HourNames.Add "9 am"
    HourNames.Add "10 am"
    HourNames.Add "11 am"
    HourNames.Add "12 n"
    HourNames.Add "1 pm"
    HourNames.Add "2 pm"
    HourNames.Add "3 pm"
    HourNames.Add "4 pm"
    HourNames.Add "5 pm"
    HourNames.Add "6 pm"
    HourNames.Add "7 pm"
    num_hours = HourNames.Count - 1
    
    DrawHours
End Sub

Private Sub TimePic_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
    Drawing = True
    
    StartY = YtoHour(Y)
    CurY = StartY
    DrawBox StartY, StartY
End Sub

Private Sub TimePic_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
    If Not Drawing Then Exit Sub
    
    CurY = YtoHour(Y)
    DrawBox StartY, CurY
End Sub


Private Sub TimePic_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
Dim tmp As Integer

    If Not Drawing Then Exit Sub
    Drawing = False
    
    If StartY > CurY Then
        tmp = StartY
        StartY = CurY
        CurY = tmp
    End If
    If CurY >= StartY Then DrawBox StartY, CurY

    ' Bounds checks added by Nico Panayi (np069@telinco.co.uk)
    If CurY > (num_hours) Then CurY = num_hours
    If StartY < 1 Then StartY = 1

    TimeLabel.Caption = HourNames(StartY) & _
        " to " & HourNames(CurY + 1)
End Sub


